close all
clear
clc

syms x i h
syms phirm philp phir phil
syms dphirm dphilm dphirp dphilp
syms ai aim aip
syms bi bim bip

phil = 1/h*(x-(i-1)*h);
phirm = -1/h*(x-((i-1)+1)*h);
phir = -1/h*(x-(i+1)*h); 
philp = 1/h*(x-((i+1)-1)*h);

dphil = 1/h;
dphirm = -1/h;
dphir = -1/h;
dphilp = 1/h;

Mcenbeg = simplify(int(phir*phir,i*h,(i+1)*h));
Mcenend = simplify(int(phil*phil,(i-1)*h,i*h));
Kcenbeg = simplify(int(dphir*dphir,x,i*h,(i+1)*h));
Kcenend = simplify(int(dphil*dphil,x,(i-1)*h,(i)*h));

Mcen = simplify(int(phil*phil,(i-1)*h,i*h)+...
                int(phir*phir,i*h,(i+1)*h));
Kcen = simplify(int(dphil*dphil,x,(i-1)*h,i*h)+...
                int(dphir*dphir,x,i*h,(i+1)*h));

Moff = simplify(int(phir*philp,i*h,(i+1)*h));
Koff = simplify(int(dphir*dphilp,x,i*h,(i+1)*h));

rhs =  simplify(int(phil*(aim*phirm+ai*phil)*(bim*phirm+bi*phil),(i-1)*h,i*h));
                %int(phir*(ai*phir+aip*philp)*(bi*phir+bip*philp),i*h,(i+1)*h));

Icarhs1 = simplify(int(phil*(aim*phirm+ai*phil),(i-1)*h,i*h));                 
Icarhs2 = simplify(int(phir*(ai*phir+aip*philp),i*h,(i+1)*h));            
                
disp('M main diagonal')
pretty(Mcen)
disp('K main diagonal')
pretty(Kcen)
disp('M main diagonal first')
pretty(Mcenbeg)
disp('M main diagonal last')
pretty(Mcenend)
disp('K main diagonal first')
pretty(Kcenbeg)
disp('K main diagonal last')
pretty(Kcenend)
disp('M off diagonal')
pretty(Moff)
disp('K off diagonal')
pretty(Koff)
disp('nonlinear rhs')
pretty(rhs)
disp('nonlinear ICa rhs1')
pretty(Icarhs1)
disp('nonlinear ICa rhs2')
pretty(Icarhs2)