function [A,b,val] = hines(A,b,nc,md)

maxdepth = max(nc.depth);

% segments

st = md.segh+1;
fin = md.segt;

% procedure TRIANG
% triangularization procedure
% do procedure by depth

for jj = maxdepth:-1:1

    cdex = find(nc.depth == jj);
 
    % do procedure on all branches of this depth
    
    for kk = 1:length(cdex)
    
        nn = cdex(kk);
       
        mi = st(nn);
        mj = fin(nn);
        ml = mj-mi+1;
        
        for ii = mi:mj
           
            rat = (A(ii,ii-1)/A(ii-1,ii-1));
            
            A(ii,ii) = A(ii,ii)-A(ii-1,ii)*rat;
            %A(ii,ii-1) = A(ii,ii-1)-A(ii-1,ii-1)*rat;
            
            b(ii) = b(ii) - b(ii-1)*rat;
            
        end

        
        % if the last segment is the connected to a hines `node'
        
        if find(nc.roots ~= nn)
            
            ii = mj;
            mk = md.segh(nc.parent(nn));

            rat = A(mk,ii)/A(ii,ii);
            
            A(mk,mk) = A(mk,mk) - A(ii,mk)*rat;
            %A(mk,ii) = A(mk,ii) - A(ii,ii)*rat;
            A(mk,ii) = 0;
            
            b(mk) = b(mk) - b(ii)*rat;

        end

    end    
    
end

% artificial elimination because we know it works

A(2:md.count.L+1:end) = 0;

% procedure BACKSUB
% back substitution step
% do procedure by depth, this time starting backward from before

for jj = 1:maxdepth

    cdex = find(nc.depth == jj);
    
    % do procedure on all branches of this depth
    
    for kk = 1:length(cdex)
    
        nn = cdex(kk);
       
        mi = st(nn);
        mj = fin(nn);
        ml = mj-mi+1;
    
        % if the last segment is the connected to a hines `node'
        % do off-diagonal backsub on this segment
        
        if find(nc.roots ~= nn)
            
            ii = mj;
            mk = md.segh(nc.parent(nn));

            val(ii) = (b(ii)-val(mk)*A(ii,mk))/A(ii,ii);
        
        % else just do normal solve for last `segment'
            
        else
            
            val(ii) = b(ii)/A(ii,ii);
            
        end
        
        for ii = mj-1:-1:md.segh(nn)
            
            val(ii) = (b(ii)-val(ii+1)*A(ii,ii+1))/A(ii,ii);
            
            
        end
        
    end
end