function ncmdout(filename,maxcompsize)

% read in data

nc = neur_converterh(filename);
nnc = nc;

% simulation time

% construct morphology

md = neur_loadmorph2(nc,maxcompsize,4)

% parameters

p_const = neur_param_const(nc);
p_conds = neur_param_conds(nc,md);

% M K L

%[md.segh,md.segt] = neur_headtailh(nc,md);

[M,K,L,b,md] = neur_assembleMKh(nc,md,p_const,p_conds);

dt = 0.05; % simulation time step
Tf = 60;

radii = md.interp.radii{1};
rhead(1) = 1;
rtail(1) = size(md.interp.radii{1},2);

Gm = p_conds.pas.G{1};
ghead(1) = 1;
gtail(1) = size(p_conds.pas.G{1},2);

for ii = 2:size(p_conds.pas.G,2)

    rtail(ii) = rtail(ii-1) + size(md.interp.radii{ii},2);
    
    radii = [radii md.interp.radii{ii}];
    
    rhead(ii) = rtail(ii-1)+1;
    
end

for ii = 2:size(p_conds.pas.G,2)

    gtail(ii) = gtail(ii-1) + size(p_conds.pas.G{ii},2);
    
    Gm = [Gm p_conds.pas.G{ii}];
    
    ghead(ii) = gtail(ii-1)+1;
    
end

LHS = M+dt*(L+K);
%RHS = M*v+simd.dt*b;

% forward connections

eachconnfdex = 1:md.count.L;
eachconnf(eachconnfdex) = eachconnfdex + 1;
eachconnf(md.segt(find(md.parents>0))) = ...
     md.segh(md.parents(find(md.parents>0))); 
eachconnf(md.segt(nc.roots)) = md.count.L;
eachconnf(end) = 0;

nodebackcount = zeros(1,md.count.L);

% backward connections

for ii = 1:md.count.L
    
    if eachconnf(ii) > 0
        nodebackcount(eachconnf(ii)) = nodebackcount(eachconnf(ii)) + 1;
        eachconnbcell{eachconnf(ii)}(nodebackcount(eachconnf(ii))) = ii;
    end
   
end

eachconnb = [];
eachconnbdexs(1) = 1;
eachconnbdexe = zeros(1,md.count.L);

for ii = 1:md.count.L

    if isempty(eachconnbcell{ii})
        eachconnbcell{ii} = [0];
    end
    
    eachconnb = [eachconnb eachconnbcell{ii}(1:end)];
    eachconnbdexs(ii+1) = eachconnbdexs(ii) + length(eachconnbcell{ii}(1:end));
    eachconnbdexe(ii) = eachconnbdexs(ii+1)-1;
    
end
eachconnbdexs(end) = [];

nr = length(nc.roots);

nn = md.count.L;
nb = md.count.N;
mhead = md.segh';
mtail = md.segt';
conns = md.parents';
rootdex = nc.roots;
notrootdex = 1:md.count.N;
notrootdex(rootdex) = [];
hstep = md.grid.hstep;

save neurinfo nn nb nr conns eachconnf...
     mhead mtail rhead rtail ghead gtail ... 
     radii Gm hstep -ASCII
 
save siminfo dt Tf -ASCII

fprintf('\n')