function neur_recguih(action,dendnum,vdat,nc,md)

if strcmp(action,'init'),
    oldFigNumber=watchon;

    figNumber=figure( ...
        'Visible','off', ...
        'NumberTitle','off', ...
        'ToolBar','auto',...
        'Color','white', ...
        'Name',['Branch ' num2str(dendnum)]);
    colordef(figNumber,'white')
    axh1 = axes( ...
        'Units','normalized', ...
        'Position',[0.1 0.44 0.58 0.50]);
    
    set(axh1,'fontsize',10)

    %===================================
    % Set up the Dendrite Window
    top=0.40;
    left=0.05;
    right=0.70;
    bottom=0.1;
    labelHt=0.05;
    spacing=0.005;
        
    % Then dendrite viewer
    mdwPos=[left bottom (right-left) top-bottom-labelHt-spacing];
    mdwHndl=axes( ...
        'Units','normalized', ...
        'Position',mdwPos);
    
    % to store data
    data = vdat;
    
    data.nc = nc;
    data.md = md;
    
    data.dendnum = dendnum;
       
    % Save this handle for future use
    % set(gcf,'UserData',mdwHndl);

    %====================================
    % Information for all buttons
    labelColor=[0.8 0.8 0.8];
    top=0.95;
    bottom=0.05;
    left=0.75;
    yInitLabelPos=0.90;
    left=0.75;
    labelWid=0.20;
    labelHt=0.05;
    btnWid=0.20;
    btnHt=0.05;
    % Spacing between the label and the button for the same command
    btnOffset=0.003;
    % Spacing between the button and the next command's label
    spacing=0.025;

    %====================================
    % The CONSOLE frame
    frmBorder=0.02;
    yPos=0.05-frmBorder;
    frmPos=[left-frmBorder yPos btnWid+2*frmBorder 0.9+2*frmBorder];
    h=uicontrol( ...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frmPos, ...
        'BackgroundColor',[0.50 0.50 0.50]);
    
    %====================================
    % The TRACE 1 command popup button
    btnNumber=3;
    yLabelPos=top-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Trace 1';
    
    popupStr1 = 'nothing selected';

    jj = dendnum;
    
    for ii = 1:md.interp.size(jj)
        popupStr1 = str2mat(popupStr1,['Node ' num2str(ii)]);
    end
    
    callbackStr='neur_recguih(''trace'')';
    
    % Generic label information
    labelPos=[left yLabelPos-labelHt labelWid labelHt];
    uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',labelColor, ...
        'HorizontalAlignment','left', ...
        'String',labelStr);

    % Generic popup button information
    btnPos=[left yLabelPos-labelHt-btnHt-btnOffset btnWid btnHt];
    hndl1=uicontrol( ...
        'Style','popup', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',popupStr1, ...
        'Callback',callbackStr,...
        'UserData',data);
    
    set(hndl1,'Value',2);    

    %====================================
    % The TRACE 2 command popup button
    btnNumber=4;
    yLabelPos=top-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Trace 2';
    callbackStr='neur_recguih(''trace'')';
    
    % Generic label information
    labelPos=[left yLabelPos-labelHt labelWid labelHt];
    uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',labelColor, ...
        'HorizontalAlignment','left', ...
        'String',labelStr);

    % Generic popup button information
    btnPos=[left yLabelPos-labelHt-btnHt-btnOffset btnWid btnHt];
    hndl2=uicontrol( ...
        'Style','popup', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',popupStr1, ...
        'Callback',callbackStr);
    
    set(hndl2,'Value',ceil((data.md.grid.comps(dendnum))/2)+2);    

    %====================================
    % The TRACE 3 command popup button
    btnNumber=5;
    yLabelPos=top-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Trace 3';
    callbackStr='neur_recguih(''trace'')';
    
    % Generic label information
    labelPos=[left yLabelPos-labelHt labelWid labelHt];
    uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',labelColor, ...
        'HorizontalAlignment','left', ...
        'String',labelStr);

    % Generic popup button information
    btnPos=[left yLabelPos-labelHt-btnHt-btnOffset btnWid btnHt];
    hndl3=uicontrol( ...
        'Style','popup', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',popupStr1, ...
        'Callback',callbackStr);
    
    set(hndl3,'Value',data.md.grid.comps(dendnum)+2);    

    %====================================
    % The PLOT command popup button
    btnNumber=6;
    yLabelPos=top-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Plot Type';
    labelList=' trace| full-trace| surf';
    callbackStr='neur_recguih(''plottype'')';
    
    % Generic label information
    labelPos=[left yLabelPos-labelHt labelWid labelHt];
    uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',labelColor, ...
        'HorizontalAlignment','left', ...
        'String',labelStr);

    % Generic popup button information
    btnPos=[left yLabelPos-labelHt-btnHt-btnOffset btnWid btnHt];
    hndl4=uicontrol( ...
        'Style','popup', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',labelList, ...
        'Callback',callbackStr);

    %====================================
    % The DATA command popup button
    btnNumber=1;
    yLabelPos=top-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Data Type';
    labelList=' Potentials| I_Na| I_K| I_Ca L-Type| I_A| [Ca]| [CaB]| [CaE]';
    callbackStr='neur_recguih(''datatype'')';
    
    % Generic label information
    labelPos=[left yLabelPos-labelHt labelWid labelHt];
    uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',labelColor, ...
        'HorizontalAlignment','left', ...
        'String',labelStr);

    % Generic popup button information
    btnPos=[left yLabelPos-labelHt-btnHt-btnOffset btnWid btnHt];
    hndl5=uicontrol( ...
        'Style','popup', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',labelList, ...
        'Callback',callbackStr);
    
    set(hndl5,'Value',1);

    %====================================
    % Info button
    uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',[left bottom+1*btnHt+spacing btnWid 1*btnHt], ...
        'String','Clear Traces', ...
        'Callback','neur_recguih(''clear'')');

    % The close button.
    uicontrol( ...
        'Style','pushbutton', ...
        'Units','normalized', ...
        'Position',[left bottom btnWid 1*btnHt], ...
        'String','Close', ...
        'Callback','close(gcf)');

        
    % Uncover the figure
    hndlList=[mdwHndl axh1 hndl1 hndl2 hndl3 hndl4 hndl5];
    watchoff(oldFigNumber);
    set(figNumber,'Visible','on', ...
        'UserData',hndlList);
    
    % initialize the plots
    
    axes(mdwHndl)
    hold on
    ell = nc.lendata{dendnum}(end);
    xpl = linspace(0,ell,md.interp.size(dendnum));
    plot(xpl,zeros(1,length(xpl)),'y-d','LineWidth',4)
    xlabel('distance from parent node(\mum)')
    %set(gca,'YColor',[1 1 1])
    set(gca,'YTickLabel',[])
    
    if find(nc.roots == dendnum)
        h = text(0,-0.5,'(Soma)');
        set(h,'Color','black')
        plot(0,0,'yd','LineWidth',7)
    else
        h = text(0,-0.5,'(Branch Point)');
        set(h,'Color','black')
        plot(0,0,'yd','LineWidth',7)
    end
    
    neur_recguih('datatype')
    
elseif strcmp(action,'clear') & nargin == 1,
   
    hndlList=get(gcf,'UserData');
    
    hndl1=hndlList(3);
    hndl2=hndlList(4);
    hndl3=hndlList(5);
    
    set(hndl1,'Value',1);
    set(hndl2,'Value',1);
    set(hndl3,'Value',1);
    
    neur_recguih('plottype')
    
elseif strcmp(action,'datatype') && nargin == 1,
    
    hndlList=get(gcf,'UserData');
    axh1 = hndlList(2);
    hndl1 = hndlList(3);
    hndl5 = hndlList(7);
    data = get(hndl1,'UserData');
    
    res = get(hndl5,'Value');
    
    switch(res)
        
        case 1 
            data.sd = data.v;
            data.stype = 1;
        case 2
            data.sd = data.INa;
            data.stype = 2;
        case 3
            data.sd = data.IK;
            data.stype = 2;            
        case 4
            data.sd = data.IL;
            data.stype = 2;            
        case 5
            data.sd = data.IA;
            data.stype = 2;            
        case 6
            data.sd = data.Ca;
            data.stype = 3;            
        case 7
            data.sd = data.CaB;
            data.stype = 3;            
        case 8
            data.sd = data.CaE;
            data.stype = 3;            
    end
    
    set(hndl1,'UserData',data);

    neur_recguih('plottype')
    
elseif strcmp(action,'plottype') & nargin == 1,
     
    hndlList=get(gcf,'UserData');
    mdwHndl=hndlList(1);
    axh1=hndlList(2);
    
    hndl1=hndlList(3);
    hndl4=hndlList(6);
    
    data = get(hndl1,'UserData');
    
    res = get(hndl4,'Value');
    
    switch(res)
        
        case 1
            neur_recguih('trace')
           
        case 2
            neur_recguih('fulltrace')
            
        case 3
            axes(axh1)
            cla
            hold on
            
            xlabel('t (ms)')
            axislabels3d(data.stype);
            %ylabel('compartment')
            %zlabel('potential (mV)')

            %title('Membrane Potentials')
            
            %feature('UseGenericOpenGL',1)
            surfl(data.t,data.x,data.sd)
            view(35,35)
            colormap bone
            shading interp
            %light('Position',[0 0 30],'Style','infinite')
    end
    
    if res > 3
        
        axes(mdwHndl)
        cla
        hold on
        ell = data.nc.lendata{data.dendnum}(end);
        xpl = linspace(0,ell,data.md.interp.size(data.dendnum));
        plot(xpl,zeros(1,length(xpl)),'yd','LineWidth',4)
        %xlabel('distance (\mum)')
        %set(gca,'YColor',[1 1 1])
        set(gca,'YTickLabel',[])


        if find(data.nc.roots == data.dendnum)
            h = text(0,-0.5,'(Soma)');
            set(h,'Color','black')
            plot(0,0,'yd','LineWidth',7)
            xlabel('distance from soma (\mum)')
        else
            h = text(0,-0.5,'(Branch Point)');
            set(h,'Color','black')
            plot(0,0,'yd','LineWidth',7)
            xlabel('distance from parent node (\mum)')
        end
    
    end
elseif strcmp(action,'trace') & nargin == 1,
    
    hndlList=get(gcf,'UserData');
    mdwHndl=hndlList(1);
    axh1=hndlList(2);
    
    hndl1=hndlList(3);
    hndl2=hndlList(4);
    hndl3=hndlList(5);
    hndl4=hndlList(6);
    
    data = get(hndl1,'UserData');
    res(1) = get(hndl1,'Value')-1;
    res(2) = get(hndl2,'Value')-1;
    res(3) = get(hndl3,'Value')-1;
    
    res(4) = get(hndl4,'Value');
    
    switch(res(4))
        case 1
            axes(axh1)
            cla
            hold on
            view(2)
            
            xlabel('t (ms)')%, ylabel('potential (mV)')
            axislabels2d(data.stype);
            %title('Membrane Potentials')

            if res(1) > 0

                plot(data.t,data.sd(res(1),:),'r');

            end

            if res(2) > 0

                plot(data.t,data.sd(res(2),:),'g');

            end

            if res(3) > 0

                plot(data.t,data.sd(res(3),:),'b');

            end

            axes(mdwHndl)
            cla
            hold on
            ell = data.nc.lendata{data.dendnum}(end);
            xpl = linspace(0,ell,data.md.interp.size(data.dendnum));
            plot(xpl,zeros(1,length(xpl)),'y-d','LineWidth',4)
            xlabel('distance (\mum)')
            %set(gca,'YColor',[1 1 1])
            set(gca,'YTickLabel',[])

            if find(data.nc.roots == data.dendnum)
                h = text(0,-0.5,'(Soma)');
                set(h,'Color','black')
                plot(0,0,'yd','LineWidth',7)
            else
                h = text(0,-0.5,'(Branch Point)');
                set(h,'Color','black')
                plot(0,0,'yd','LineWidth',7)
            end

            if res(1) > 0

                h = text(xpl(res(1)),0.5,'1','fontsize',18);
                set(h,'Color','red')
                plot(xpl(res(1)),0,'rd','LineWidth',2)
            end

            if res(2) > 0

                h = text(xpl(res(2)),0.5,'2','fontsize',18);
                set(h,'Color','green')
                plot(xpl(res(2)),0,'gd','LineWidth',2)
            end

            if res(3) > 0

                h = text(xpl(res(3)),0.5,'3','fontsize',18);
                set(h,'Color','blue')
                plot(xpl(res(3)),0,'bd','LineWidth',2)
            end

        case 2
            
            neur_recguih('fulltrace')

    end
    
elseif strcmp(action,'fulltrace') & nargin == 1,

    hndlList=get(gcf,'UserData');
    mdwHndl=hndlList(1);
    axh1=hndlList(2);
    
    hndl1=hndlList(3);
    hndl2=hndlList(4);
    hndl3=hndlList(5);
    hndl4=hndlList(6);

    data = get(hndl1,'UserData');
    res(1) = get(hndl1,'Value')-1;
    res(2) = get(hndl2,'Value')-1;
    res(3) = get(hndl3,'Value')-1;

    axes(axh1)
    cla
    hold on
    view(3)
    
    xlabel('t (ms)')
    axislabels3d(data.stype);
    %ylabel('compartment')
    %zlabel('potential (mV)')
    
    %title('Membrane Potentials')

    for ii = 1:size(data.v,1)

        plot3(data.t,...
            ones(length(data.t),1)*ii,...
            data.sd(ii,:),'k')

    end
    
    if res(1) > 0
        
        plot3(data.t,ones(length(data.t),1)*res(1),...
              data.sd(res(1),:),'r');
    
    end        
    
    if res(2) > 0
        
        plot3(data.t,ones(length(data.t),1)*res(2),...
              data.sd(res(2),:),'g');
    
    end
    
    if res(3) > 0
        
        plot3(data.t,ones(length(data.t),1)*res(3),...
              data.sd(res(3),:),'b');
    
    end
    
    axes(mdwHndl)
    cla
    hold on
    ell = data.nc.lendata{data.dendnum}(end);
    xpl = linspace(0,ell,data.md.interp.size(data.dendnum));
    plot(xpl,zeros(1,length(xpl)),'y-d','LineWidth',4)
    %xlabel('distance (\mum)')
    %set(gca,'YColor',[1 1 1])
    set(gca,'YTickLabel',[])
    
    if find(data.nc.roots == data.dendnum)
        h = text(0,-0.5,'(Soma)');
        set(h,'Color','black')
        plot(0,0,'yd','LineWidth',7)
        xlabel('distance from soma (\mum)')
    else
        h = text(0,-0.5,'(Branch Point)');
        set(h,'Color','black')
        plot(0,0,'yd','LineWidth',7)
        xlabel('distance from parent node (\mum)')
    end
    
    if res(1) > 0
        
        h = text(xpl(res(1)),0.5,'1','fontsize',18);
        set(h,'Color','red')
        plot(xpl(res(1)),0,'rd','LineWidth',2)
    end        
    
    if res(2) > 0
        
        h = text(xpl(res(2)),0.5,'2','fontsize',18);
        set(h,'Color','green')
        plot(xpl(res(2)),0,'gd','LineWidth',2)
    end
    
    if res(3) > 0
        
        h = text(xpl(res(3)),0.5,'3','fontsize',18);
        set(h,'Color','blue')
        plot(xpl(res(3)),0,'bd','LineWidth',2)
    end
    
elseif strcmp(action,'eval') & nargin == 1,
    % Assemble and execute the completed command 
    
end;    % if strcmp(action, ...

function axislabels2d(in)

switch(in)
    
    case 1
        ylabel('mV')
    case 2
        ylabel('\muA/cm^2')
    case 3
        ylabel('\mumol/L')
end

function axislabels3d(in)

ylabel('compartment')

switch(in)
    
    case 1
        zlabel('mV')
    case 2
        zlabel('\muA/cm^2')
    case 3
        zlabel('\mumol/L')
end