function [v,t] = neur_solverh(M,K,L,b,md,p_const,p_conds,...
                              simd,filename)

WRITEF1 = fopen([filename '.n1'],'w');
WRITEF2 = fopen([filename '.n2'],'w');
WRITEF3 = fopen([filename '.n3'],'w');

fwrite(WRITEF3,md.count.L,'double');
fwrite(WRITEF3,md.count.N,'double');
fwrite(WRITEF3,md.segh,'double');
fwrite(WRITEF3,md.segt,'double');

fwrite(WRITEF2,simd.t,'double');

N = md.count.L;

io = neur_stimulus(md,simd);

tl = length(simd.t);

eo = zeros(N,1);

% current pulse at the SOMA

eo(end) = 1;

% get initial potentials
% 
% disp('Getting initial potentials...')
% 
% simd.T2 = simd.T*50;
% simd.dt2 = simd.dt*500;
% 
% LHS = M+simd.dt2*(L+K);
% [Lmat,Umat] = lu(LHS);
% 
% j = 2;
% t(1) = 0;
% v = ones(N,1)*parm.pas.v; 
% 
% jfinal = simd.T2/simd.dt2;
% jtenper = jfinal/10;
% 
% while (j-1)*simd.dt2 <= simd.T2
% 
%    t(j) = (j-1)*simd.dt2;
% 
%    RHS = M*v+simd.dt2*b;
%  
%    v = Umat \ (Lmat \ RHS);
% 
%    %v(:,j) = LHS \ RHS;
%       
%    j = j + 1;
% 
%    if mod(j,jtenper) == 0 
%     
%        disp([num2str(j/jtenper*10) ' % done'])
%        
%    end
%  
% end
% 
% disp('Solving...')
% 

v = ones(N,1)*p_const.pas.v; 

LHS = M+simd.dt*(L+K);
[Lmat,Umat] = lu(LHS);

j = 2;
t(1) = 0;

fwrite(WRITEF1,v,'double');

jfinal = simd.T/simd.dt;
jtenper = jfinal/10;

while (j-1)*simd.dt <= simd.T

   t(j) = (j-1)*simd.dt;

   RHS = M*v+simd.dt*(b+io(j-1)*eo); 
 
   v = Umat \ (Lmat \ RHS);

   %v(:,j) = LHS \ RHS;
   
   fwrite(WRITEF1,v,'double');
   
   j = j + 1;

   if mod(j,jtenper) == 0 
    
       disp([num2str(j/jtenper*10) ' % done'])
       
   end
 
end

function io = neur_stimulus(md,simd)

if simd.Is.end > simd.T
    simd.Is.end = simd.T;
end

io = zeros(length(simd.t),1);

startindex = simd.Is.start/simd.dt+1;
endindex = simd.Is.end/simd.dt;

io(startindex:endindex) = simd.Is.mag*1/(2*pi);

% io = simd.Is.mag*simd.t.*exp(-simd.t);
% io = io/(2*pi);