close all
clear all

finex= 400;
T = 10;

disp('exact solution...')

dt = 0.0025;

% if ~exist('vex')
%     vex = paxon_ex(50,finedt,10,4);
% end

load vex vex

finet = 0:dt:10;

disp('done')

% read in data

filename = 'test.asc'

nc = neur_converterh(filename);

% simulation time

simd.dt = dt;   % ms
simd.T = T;    % ms

simd.Is.start = 0;  % ms
simd.Is.end = T;   % ms

% current pulse

simd.Is.mag = 1;  % uA
%simd.Is.mag = 0;  % nA

simd.t = 0:simd.dt:simd.T;

% Hines solver

disp('M,K,L ready')

disp('Solving system...')

simpatches = 10:10:100;

for jj = 1:length(simpatches)

    % construct morphology

    simpatches(jj)
    md = neur_loadmorph_direct(nc,[simpatches(jj)],1)
    hstep(jj) = md.grid.hstep(1)
    
    % parameters

    p_const = neur_param_const(nc);
    p_conds = neur_param_conds(nc,md);
    
    % M K L

    [M, K, L, b, md] = neur_assembleMKh(nc,md,p_const,p_conds);

    save ncmd nc md

    % solve for v

    tic
    [v,t] = neur_solverh(M,K,L,b,md,p_const,p_conds,simd,filename);
    toc

    fprintf('\n')
    out = neur_read('test.asc')
    out.v = out.v(end:-1:1,:)-p_const.pas.v;

    %for ii = 1:length(finet)

        pl = mkpl(0:hstep(jj):1,out.v(:,end));
        femv = ppval(pl,0:0.0025:1);

    %end
    
    maxerr(jj) = max(abs(femv'-vex(:,end)));

end

plot(hstep,maxerr,'-o')
xlabel('space step'),ylabel('max|error| (mv)')
title(['time step: ' num2str(dt)])